// Given name as parameter to this application, launch execution 
// of a program or open the given file with default association.
//
// Useful for autorun launch of HTML file
//
// Modification history
// Joe Nord   08-Feb-2000  Create
// Joe Nord   07-Jun-2006  Change to use SW_SHOWNORMAL on launch rather than hide

#include <windows.h>

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>


// pszFile is non-null/non-empty name of file to launch.
void Launch (LPCTSTR pszFile)
{
    SHELLEXECUTEINFO Info;

    memset (&Info, '\0', sizeof(Info));

    Info.cbSize = sizeof(Info);
    Info.fMask = 0;
    Info.hwnd = NULL;
    Info.lpVerb = TEXT("open");
    Info.lpFile = pszFile;
    Info.lpParameters = NULL;
    Info.lpDirectory = NULL;
    Info.nShow = SW_SHOWNORMAL;
    ShellExecuteEx (&Info);
}

int PASCAL WinMain (HINSTANCE hInstance,
                    HINSTANCE hPrevInstance, // For Win32, always NULL
                    LPSTR lpCmdLine, 
                    int nCmdShow)
{
    size_t Len;

    Len = strlen (lpCmdLine);
    if (Len == 0)
    {
        MessageBox (NULL, "Syntax: ShellEx <d:\\path\\Filename.ext>", NULL, 0);
    }
    else
    {
        Launch (lpCmdLine);
    }
    return (0);
}